unit uKlassen;

interface

uses sysutils;

type

tzeiger=^element;

element=record
daten:string;
next:tzeiger;
end;

tqueue=class
private
zkopf, zneu, zhilf:Tzeiger;
public
procedure enqueue(s:string); // einfgen AM ENDE
procedure dequeue;            // lschen am Kopf
function ausgabe:string;
end;

tstack=class
private
zkopf, zneu, zhilf:Tzeiger;
public
procedure push(s:string);  // einfgen am KOPF
procedure pop;               // Lschen am Kopf
function ausgabe:string;
function oben:string;
procedure leeren;
end;

implementation

//*************TQueue****************************

procedure tqueue.enqueue(s:string);
begin
new(zneu); // "new" reserviert auch den Speicher, auf den zneu zeigt
zneu^.daten:=s; // daher kann ich diesen Speicher (zneu^= der Speicher, auf den zneu zeigt) beschreiben
zneu^.next:=nil;// den Zeiger brauche ich noch nicht, daher lasse ich ihn auf NIL zeigen (="erden")
if zkopf=nil then // ist die Liste leer...
zkopf:=zneu else// ...wird mein zneu zum neuen Kopf, ansonsten
 begin
 zhilf:=zkopf;   // Ich setze einen Hilfszeiger auf den Kopf der Liste...
 while zhilf^.next<>nil do // ...und solange noch ein Element folgt...
 zhilf:=zhilf^.next;  // ... klappere ich sie Element fr Element ab
 zhilf^.next:=zneu; //Ist die Schleife durch, bin ich am Ende der Liste. Hier hnge ich mein neues Element an.
 end;
end;

procedure tqueue.dequeue;
begin
if zkopf<>nil then // Ist die Liste nicht leer...
 begin
 zhilf:=zkopf;   // Setze ich einen Hilfszeiger auf den Kopf (=ich merke mir seine Adresse, damit ich ihn spter lschen kann)
 zkopf:=zkopf^.next;// dann mache ich das zweite Element zum neuen Kopf.
 dispose(zhilf);// Da ich die Adresse des alten Kopfes in zhilf gespeichert habe, kann ich ihn lschen und den Speicher, auf dener zeigt, leeren.
 end;
end;

function tqueue.ausgabe:string;
begin
result:='';  // Das Ergebnis wird ein String, daher muss ich mit einem leeren String anfangen.
if zkopf<>nil then // Wenn die Liste nicht leer ist...
 begin
 zhilf:=zkopf;  //... setze ich einen Hilfszeuger an den Anfang der Liste.
 while zhilf<>nil do // Solange ich noch auf einem vorhandenen Element bin....
  begin
  result:=result+zhilf^.daten+#13#10; //... fge ich seine Daten zum Ergebnis-String hinzu...
  zhilf:=zhilf^.next;                // und ziehe anschlieend weiter zum nchsten Element.
  end;
 end;
end;

//*************TStack****************************

procedure tstack.push(s:string);  // beim Stack wird am Kopf eingefgt
begin
new(zneu);  // erstmal wie gehabt neuen Speicher reservieren (zneu zeigt darauf = ist seine Adresse)
zneu^.daten:=s; // Daten reinschreiben
zneu^.next:=nil;  // Zeiger erden
if zkopf=nil then zkopf:=zneu else  //s.o.
 begin
 zneu^.next:=zkopf; // den alten Kopf an mein neues Element anhngen
 zkopf:=zneu; // mein neues Element zum neuen Kopf ernennen
 end;
end;

procedure tstack.pop; // heit einfach nur am Kopf lschen, s.o. dequeue
begin
if zkopf<>nil then
 begin
 zhilf:=zkopf;
 zkopf:=zkopf^.next;
 dispose(zhilf);
 end;
end;

function tstack.oben:string;
begin
 if zkopf=nil then result:='' else
 result:=zkopf^.daten;
end;

function tstack.ausgabe:string;
begin
result:='';
if zkopf<>nil then
 begin
 zhilf:=zkopf;
 while zhilf<>nil do
  begin
  result:=result+zhilf^.daten+#13#10;
  zhilf:=zhilf^.next;
  end;
 end;
end;

procedure tstack.leeren;
begin
  while zkopf<>nil do pop;

end;

end.
